% Esercitazioni di Controllo Digitale A.A. 2002/2003
% Titolare del corso Prof. A. Bemporad
% Esercitazioni tenute da Ing. Nicolo' Giorgetti
%
% 2 masse accoppiate da una molla e uno smorzatore, una forza spinge la prima e 
% si misura la posizione della seconda massa.
%
% Argomenti introdotti: + pole placement
%                       + controllo LQR
%                       + simulazione sistema ad anello chiuso

% Parametri del modello
k=1;
beta=2;
m1=10;
m2=10;

% Rappresentazione spazio di stato
A=[0 1 0 0;...
      -k/m1 -beta/m1 k/m1 beta/m1;...
      0 0 0 1;
      k/m1 beta/m2 -k/m2 -beta/m2];
b=[0 1/m1 0 0]';
c=[0 0 1 0];
d=[0];
sys_2m=ss(A,b,c,d)


% Aggiunta dell'integratore
AA=[A zeros(4,1); c 0]; % sistema aumentato con dq(t)/dt=y(t)
BB=[b; 0];
CC=[c 0];
DD=0;

% Calcolo della retroazione ottima LQR
QQ=10*eye(5);
R=1;       % provare a porre R=5

KK=-lqr(AA,BB,QQ,R)  % u=K[x;q]

x0=[10 0 11 0]';

T=sim('masse_int_sim',100);





   
   
